(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var check = Package.check.check;
var Match = Package.check.Match;
var Accounts = Package['accounts-base'].Accounts;

/* Package-scope variables */
var AccountsUi, SandstormAccountSettingsUi;

(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                             //
// packages/sandstorm-accounts-ui/accounts-ui-server.js                                        //
//                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                               //
// Sandstorm - Personal Cloud Sandbox                                                          // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                       // 2
// All rights reserved.                                                                        // 3
//                                                                                             // 4
// Licensed under the Apache License, Version 2.0 (the "License");                             // 5
// you may not use this file except in compliance with the License.                            // 6
// You may obtain a copy of the License at                                                     // 7
//                                                                                             // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                // 9
//                                                                                             // 10
// Unless required by applicable law or agreed to in writing, software                         // 11
// distributed under the License is distributed on an "AS IS" BASIS,                           // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                    // 13
// See the License for the specific language governing permissions and                         // 14
// limitations under the License.                                                              // 15
                                                                                               // 16
// Meteor permits users to modify their own profile by default, for some reason.               // 17
Meteor.users.deny({                                                                            // 18
  insert: function () { return true; },                                                        // 19
  update: function () { return true; },                                                        // 20
  remove: function () { return true; },                                                        // 21
  fetch: []                                                                                    // 22
});                                                                                            // 23
                                                                                               // 24
/////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                             //
// packages/sandstorm-accounts-ui/accounts-ui-methods.js                                       //
//                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                               //
// Sandstorm - Personal Cloud Sandbox                                                          // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                       // 2
// All rights reserved.                                                                        // 3
//                                                                                             // 4
// Licensed under the Apache License, Version 2.0 (the "License");                             // 5
// you may not use this file except in compliance with the License.                            // 6
// You may obtain a copy of the License at                                                     // 7
//                                                                                             // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                // 9
//                                                                                             // 10
// Unless required by applicable law or agreed to in writing, software                         // 11
// distributed under the License is distributed on an "AS IS" BASIS,                           // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                    // 13
// See the License for the specific language governing permissions and                         // 14
// limitations under the License.                                                              // 15
                                                                                               // 16
// This file contains method definitions which are available on both client and server (on the // 17
// client for prediction purposes, on the server for actual execution).                        // 18
                                                                                               // 19
var ValidHandle = Match.Where(function (handle) {                                              // 20
  check(handle, String);                                                                       // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                 // 22
});                                                                                            // 23
                                                                                               // 24
Meteor.methods({                                                                               // 25
  updateProfile: function (profile) {                                                          // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                        // 27
    check(profile, {                                                                           // 28
      name: Match.OneOf(null, Match.Optional(String)),                                         // 29
      handle: Match.Optional(ValidHandle),                                                     // 30
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot")),              // 31
    });                                                                                        // 32
                                                                                               // 33
    if (!this.userId) {                                                                        // 34
      throw new Meteor.Error(403, "not logged in");                                            // 35
    }                                                                                          // 36
                                                                                               // 37
    Meteor.users.update(this.userId, {$set: {                                                  // 38
      "profile.name": profile.name,                                                            // 39
      "profile.handle": profile.handle,                                                        // 40
      "profile.pronoun": profile.pronoun                                                       // 41
    }});                                                                                       // 42
  },                                                                                           // 43
});                                                                                            // 44
                                                                                               // 45
if (Meteor.isServer) {                                                                         // 46
  // Methods that can't be simulated.                                                          // 47
                                                                                               // 48
  Meteor.methods({                                                                             // 49
    uploadProfilePicture: function () {                                                        // 50
      if (!this.userId) {                                                                      // 51
        throw new Meteor.Error(403, "Must log in to upload profile picture.");                 // 52
      }                                                                                        // 53
                                                                                               // 54
      return this.connection.sandstormDb.newAssetUpload({                                      // 55
        profilePicture: { userId: this.userId }                                                // 56
      });                                                                                      // 57
    },                                                                                         // 58
                                                                                               // 59
    cancelUploadProfilePicture: function (id) {                                                // 60
      check(id, String);                                                                       // 61
      this.connection.sandstormDb.fulfillAssetUpload(id);                                      // 62
    },                                                                                         // 63
  });                                                                                          // 64
}                                                                                              // 65
                                                                                               // 66
/////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-accounts-ui'] = {
  AccountsUi: AccountsUi,
  SandstormAccountSettingsUi: SandstormAccountSettingsUi
};

})();

//# sourceMappingURL=sandstorm-accounts-ui.js.map
